from piston.handler import BaseHandler

class MyWrapper(object):

    def __init__(self, wrapped):
        self.__wrapped__ = wrapped

    def __get__(self, instance, klass):
        if instance is None:
            return self
        descriptor = self.__wrapped__.__get__(instance, klass)
        return self.__class__(descriptor)

    def __call__(self, *args, **kwargs):
        return self.__wrapped__(*args, **kwargs)

def decorator(function):
    return MyWrapper(function)

class MyHandler(BaseHandler):
    allowed_methods = ('GET',)

    @decorator
    def read(cls, request, arg):
        return "hi"
